﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Optimization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Networks.IntegratedOptimization {
  [Item("Variegation Problem", "Represents a problem whose objective is to optimize problem parameters.")]
  [Creatable(CreatableAttribute.Categories.Problems, Priority = 999)]
  [StorableClass]
  public class VariegationProblem : SingleObjectiveBasicProblem<RealVectorEncoding> {
    public override bool Maximization {
      get { return true; }
    }

    [StorableConstructor]
    protected VariegationProblem(bool deserializing) : base(deserializing) { }
    protected VariegationProblem(VariegationProblem original, Cloner cloner) : base(original, cloner) { }
    public VariegationProblem() : base() {
      Encoding.Length = 5;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new VariegationProblem(this, cloner);
    }

    public override double Evaluate(Individual individual, IRandom random) { return 0.0; }
  }
}
